Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.fasterxml.jackson.databind
Class PropertyNamingStrategy

    java.lang.Object
      com.fasterxml.jackson.databind.PropertyNamingStrategy

Direct Known Subclasses:
  PropertyNamingStrategy.PropertyNamingStrategyBase

    public abstract class PropertyNamingStrategy

extends Object

Class that defines how names of JSON properties ("external names") are derived from names of POJO methods and fields ("internal names"), in cases where they are not auto-detected and no explicit annotations exist for naming. Methods are passed information about POJO member for which name is needed, as well as default name that would be used if no custom strategy was used.

Default implementation returns suggested ("default") name unmodified.

Note that the strategy is guaranteed to be called once per logical property (which may be represented by multiple members; such as pair of a getter and a setter), but may be called for each: implementations should not count on exact number of times, and should work for any member that represent a property.

In absence of a registered custom strategy, default Java property naming strategy is used, which leaves field names as is, and removes set/get/is prefix from methods (as well as lower-cases initial sequence of capitalized characters).

Nested Class Summary
`static class` | `PropertyNamingStrategy.LowerCaseWithUnderscoresStrategy` A `PropertyNamingStrategy` that translates typical camel case Java property names to lower case JSON element names, separated by underscores.
`static class` | `PropertyNamingStrategy.PascalCaseStrategy` A `PropertyNamingStrategy` that translates typical camelCase Java property names to PascalCase JSON element names (i.e., with a capital first letter).
`static class` | `PropertyNamingStrategy.PropertyNamingStrategyBase`

Field Summary
`static PropertyNamingStrategy` | `CAMEL_CASE_TO_LOWER_CASE_WITH_UNDERSCORES` See `PropertyNamingStrategy.LowerCaseWithUnderscoresStrategy` for details.
`static PropertyNamingStrategy` | `PASCAL_CASE_TO_CAMEL_CASE` See `PropertyNamingStrategy.PascalCaseStrategy` for details.

Constructor Summary
`PropertyNamingStrategy()`

Method Summary
`String` | `nameForConstructorParameter(MapperConfig<?> config, AnnotatedParameter ctorParam, String defaultName)` Method called to find external name (name used in JSON) for given logical POJO property, as defined by given constructor parameter; typically called when building a deserializer (but not necessarily only then).
`String` | `nameForField(MapperConfig<?> config, AnnotatedField field, String defaultName)` Method called to find external name (name used in JSON) for given logical POJO property, as defined by given field.
`String` | `nameForGetterMethod(MapperConfig<?> config, AnnotatedMethod method, String defaultName)` Method called to find external name (name used in JSON) for given logical POJO property, as defined by given getter method; typically called when building a serializer.
`String` | `nameForSetterMethod(MapperConfig<?> config, AnnotatedMethod method, String defaultName)` Method called to find external name (name used in JSON) for given logical POJO property, as defined by given setter method; typically called when building a deserializer (but not necessarily only then).

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### CAMEL_CASE_TO_LOWER_CASE_WITH_UNDERSCORES

    public static final PropertyNamingStrategy CAMEL_CASE_TO_LOWER_CASE_WITH_UNDERSCORES

  See `PropertyNamingStrategy.LowerCaseWithUnderscoresStrategy` for details.

### PASCAL_CASE_TO_CAMEL_CASE

    public static final PropertyNamingStrategy PASCAL_CASE_TO_CAMEL_CASE

  See `PropertyNamingStrategy.PascalCaseStrategy` for details.

  Since:
    2.1

Constructor Detail

### PropertyNamingStrategy

    public PropertyNamingStrategy()

Method Detail

### nameForField

    public String nameForField(MapperConfig<?> config,
                               AnnotatedField field,
                               String defaultName)

  Method called to find external name (name used in JSON) for given logical POJO property, as defined by given field.

  Parameters:
    `config` - Configuration in used: either `SerializationConfig` or `DeserializationConfig`, depending on whether method is called during serialization or deserialization
    `field` - Field used to access property
    `defaultName` - Default name that would be used for property in absence of custom strategy
  Returns:
    Logical name to use for property that the field represents

### nameForGetterMethod

    public String nameForGetterMethod(MapperConfig<?> config,
                                      AnnotatedMethod method,
                                      String defaultName)

  Method called to find external name (name used in JSON) for given logical POJO property, as defined by given getter method; typically called when building a serializer. (but not always -- when using "getter-as-setter", may be called during deserialization)

  Parameters:
    `config` - Configuration in used: either `SerializationConfig` or `DeserializationConfig`, depending on whether method is called during serialization or deserialization
    `method` - Method used to access property.
    `defaultName` - Default name that would be used for property in absence of custom strategy
  Returns:
    Logical name to use for property that the method represents

### nameForSetterMethod

    public String nameForSetterMethod(MapperConfig<?> config,
                                      AnnotatedMethod method,
                                      String defaultName)

  Method called to find external name (name used in JSON) for given logical POJO property, as defined by given setter method; typically called when building a deserializer (but not necessarily only then).

  Parameters:
    `config` - Configuration in used: either `SerializationConfig` or `DeserializationConfig`, depending on whether method is called during serialization or deserialization
    `method` - Method used to access property.
    `defaultName` - Default name that would be used for property in absence of custom strategy
  Returns:
    Logical name to use for property that the method represents

### nameForConstructorParameter

    public String nameForConstructorParameter(MapperConfig<?> config,
                                              AnnotatedParameter ctorParam,
                                              String defaultName)

  Method called to find external name (name used in JSON) for given logical POJO property, as defined by given constructor parameter; typically called when building a deserializer (but not necessarily only then).

  Parameters:
    `config` - Configuration in used: either `SerializationConfig` or `DeserializationConfig`, depending on whether method is called during serialization or deserialization
    `ctorParam` - Constructor parameter used to pass property.
    `defaultName` - Default name that would be used for property in absence of custom strategy

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2012 FasterXML. All Rights Reserved.